!===========
program main 
!===========
!
  use deftype
  use operateur
  use solveur_system
  use sortie

!
        implicit none
!
	real (kind = 8), dimension (:,:), allocatable :: A
	real (kind = 8), dimension (:), allocatable :: b,p,q
        
        type (MOCA), dimension(:), allocatable :: promo23

!
!
        integer                     :: Nx,Ny,Nz,i, j, k
        real ( kind = 8)            ::eps, dx, dy, dz,L,H,x,y,pi


!
        pi=4*atan(1.d0)
        Nx=80
        L=2.d0*pi
        H=4.d0*pi
        Ny=90

        dx=L/(Nx+1)
        dy=H/(Ny+1)

!        
!       allocation des tableaux
!

        allocate(promo23(3),p(Nx*Ny),q(Nx*Ny))

        promo23(1)%nom='dupont'
        promo23(1)%prenom='toto'
        promo23(2)%nom='duval'
        promo23(2)%prenom='titi'
        promo23(3)%nom='foo'
        promo23(3)%prenom='bar'
        do i=1,3
           promo23(i)%note=12
        end do

        
        do i=1,3
          print*,promo23(i)
        end do
   



        call laplacien ( A,dx,dy,Nx,Ny)

        k=0
        do j=1,Ny
           do i=1,Nx
              k=k+1
              x=(i)*dx
              y=(j)*dy
              p(k)=sin(x)*sin(y)
           end do
        end do

        q=matmul(A,p)
        
        call imprim2d (1, Nx,Ny,p,q,p,p,dx,dy)

        deallocate(promo23,A,p,q)

        stop
!
!===============
end program main
!===============
